<?php
/**
 * @version     1.0.0
 * @package     com_virtualclassroom
 * @copyright   Copyright (C) 2014 BrainCert, Inc. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @website     https://www.braincert.com
 * @author      BrainCert
 */
 
defined('_JEXEC') or die;

jimport('joomla.application.component.modellist');

jimport('joomla.application.component.helper');
class virtualclassroomModellistclass extends JModelList {

   
    public function __construct($config = array()) {
        parent::__construct($config);
         
        $app =  JFactory::getApplication();
        $limit = $app -> getUserStateFromRequest('vc.list.limit', 'limit', $app -> getCfg('list_limit'), 'int');
        $limitstart = $app -> getUserStateFromRequest('vc' . '.limitstart', 'limitstart', 0, 'int');

        $this -> setState('limit', $limit);
        // Set the limit variable for query later on
        $this -> setState('limitstart', $limitstart);
    } 
	public function getPagination($total=0) {
     
         
            jimport('joomla.html.pagination');
            $this -> _pagination = new JPagination( $total, $this -> getState('limitstart'), $this -> getState('limit'));
 
     

        return $this -> _pagination;
    }
    public function getrecorcount($class_id){
        $db = JFactory::getDBO();
        $search    = JRequest::getVar('search');
        $data['task'] = 'getclassrecording';
        $data['class_id'] = $class_id;
        $bcvchelper_class = new bcvcHelper(); 
        $result = $bcvchelper_class->vlcr_get_curl_info($data);
        return $result;
    }
 public function learnerPreview($id){
        $data['task'] = 'getclass';
        $data['class_id'] = $id;
        $bcvchelper_class = new bcvcHelper(); 
        $result = $bcvchelper_class->vlcr_get_curl_info($data);
        return $result;
    }
    public function get_groupsdata(){
        $data=JRequest::get('post');
        $gid = implode(',', $data['gid']);
        $db =& JFactory::getDBO();
        $q="SELECT u.* FROM `#__user_usergroup_map` AS map LEFT JOIN `#__users` AS u ON u.`id`=map.`user_id` WHERE map.`group_id` IN (".$gid.")";
        $db->setQuery($q);
        $userids = $db->loadObjectList();
        
        $email=array();
        foreach ($userids as $key => $user) {
            $email[]=$user->email;
        }
        $data1 = array();
        $data1['id'] = $data['id'];
        $data1['email']=$email;
        $this->invite_by_email($data1);
    }
    public function invite_by_email($data1){
        $db = JFactory::getDbo();
        if(empty($data1)){
         $data1=JRequest::get('post');
        }       
        if($data1['to']){
         $data1['to'] = implode(',',explode(PHP_EOL, $data1['to']));
        }
        $data['task'] = 'getclass';
        $data['class_id'] = $data1['id'];
        $bcvchelper_class = new bcvcHelper(); 
        $classroom = $bcvchelper_class->vlcr_get_curl_info($data);

        if($data1['subject'] == ''){ $data1['subject'] ='Live Class Invitation';}
         $subject =$data1['subject'];

        if($data1['email']){
         $data1['to'] = implode(',', $data1['email']);
        }

        $to = explode(',', $data1['to']);
        $class_id = $data1['id'];
        for($i=0;$i<count($to);$i++){      
            $receiver = trim($to[$i]);
            if( $receiver == '') continue;
            $uid = uniqid(md5(rand()), true);

            $query_string = "email=".$receiver."&token=".$uid;
            $encrypted_params = openssl_encrypt ($query_string, 'aes128', 'invite@123', false, 'invite@123');

            $shorturl = substr(uniqid(md5($receiver.$class_id, true)),-12);
            $rand_number=mt_rand(10000,99999);
            $query = $db->getQuery(true);
            $columns = array('shorturl', 'fullurl', 'rand_number');
            $values = array($db->quote($shorturl), $db->quote(addslashes($encrypted_params)),  $db->quote($rand_number));

            $query
            ->insert($db->quoteName('#__virtualclassroom_shorturl'))
            ->columns($db->quoteName($columns))
            ->values(implode(',', $values));
           
            // Set the query using our newly populated query object and execute it.
            $db->setQuery($query);
            $db->execute();
            $joinclassurl = JURI::root().'index.php?option=com_virtualclassroom&view=inviteclass&shurl='.$shorturl.'&cid='.$class_id;
           $current_user = JFactory::getUSER();


                        if($receiver){ 

                            $q1 = $db->getQuery(true);
                            $conditions = array(
                                $db->quoteName('class_id') . ' = '.$db->quote($class_id), 
                                $db->quoteName('email') . ' = ' . $db->quote($receiver)
                            );
                            $q1->delete($db->quoteName('#__virtualclassroom_shared_users'));
                            $q1->where($conditions);
                            $db->setQuery($q1);
                            $db->execute();
                        }

                       
                        $objdate = date('Y-m-d H:i:s');
                       
                        $q2 = $db->getQuery(true);
                        $columns = array('class_id','email', 'uid','date');
                        $values = array($class_id, $db->quote($receiver),  $db->quote($uid),  $db->quote($objdate));

                        $q2->insert($db->quoteName('#__virtualclassroom_shared_users'))
                        ->columns($db->quoteName($columns))
                        ->values(implode(',', $values));
                        $db->setQuery($q2);
                        $db->execute();

               ob_start();
             ?>
             <div>
                    <p>
                    <?php echo $current_user->username; ?> has invited you to join the Live Class at BrainCert.</p>
                    <?php if($data1['message']){ echo $data1['message'];}?>
                    <p>Class Name: <?php echo $classroom[0]['title'];?></p>
                    <p>Date/Time: <?php echo date('l F j, Y',strtotime($classroom[0]['date'])).' '. $classroom[0]['start_time'] .$classroom[0]['end_time'];?></p>
                     
                    <p>Time Zone: <?php echo $classroom[0]['timezone_label']; ?></p>
                    <p>Duration: <?php echo $classroom[0]['duration']/60; ?></p>

                    <p>Click on the link below to join the class:</p>
                    <p><a href="<?php echo $joinclassurl;?>"><?php echo $joinclassurl; ?></a></p>
                 
                   <p> Thank you.</p>
             </div>
             <?php
             $mail_body = ob_get_contents();
             ob_clean();
             $jconfig = new JConfig();
             $from = $jconfig->mailfrom;
             $fromname = $jconfig->fromname;
             JFactory::getMailer()->sendMail($from, $fromname, $receiver, $subject, $mail_body, $mode=1);
        }
        return;
 
}
  public function getclasslaunch($class_id,$class_title){
        $db = JFactory::getDBO();
        $user = JFactory::getUser();
        $query="select * from #__virtualclassroom_teacher where user_id='".$user->id."' ";
        $db->setQuery($query);
        $teacher=$db->loadObject();

        if (@$teacher->is_teacher == 1)
        { $data['isTeacher'] = 1; }
        else {  $data['isTeacher'] = 0;  }
        $data['userId'] = $user->id;
        $data['userName'] = $user->name;
        $data['lessonName'] = $class_title;
        $data['courseName'] = $class_title;
        $data['task'] = 'getclasslaunch';
        $data['class_id'] = $class_id;
        $bcvchelper_class = new bcvcHelper(); 
        $result = $bcvchelper_class->vlcr_get_curl_info($data);
        return $result;
   }
public function activeclass(){
      $app = JFactory::getApplication();
      $class_id = JRequest::getVar('id');
      $data['isCancel'] = 0;
      $data['class_id'] = $class_id;
      $data['task'] = 'cancelclass';
      $bcvchelper_class = new bcvcHelper(); 
      $result = (object)$bcvchelper_class->vlcr_get_curl_info($data);
      if($result->status=="ok"){
        $msg = "Class active successfully";
      }else{
        $msg = $result->error;
      }
      $url="index.php?option=com_virtualclassroom&view=listclass";
      $app -> redirect($url,$msg);
    }
    public function cancelclass(){
      $app = JFactory::getApplication();
      $class_id = $_REQUEST['id'];
      $data['isCancel'] = $_REQUEST['isCancel'];
      $data['class_id'] = $class_id;
      $data['task'] = 'cancelclass';
      $bcvchelper_class = new bcvcHelper(); 
      $result = (object)$bcvchelper_class->vlcr_get_curl_info($data);
      if($result->status=="ok"){
        $msg = "Class cancel successfully";
      }else{
        $msg = $result->error;
      }
      $url="index.php?option=com_virtualclassroom&view=listclass";
      $app -> redirect($url,$msg);
    }
public function userlist(){
        $db =& JFactory::getDBO();
        $query = "SELECT * FROM #__users" ;
        $db->setQuery($query);
        return $rows = $db->loadObjectList();
}
public function getUserDeail($id){
        $db =& JFactory::getDBO();
        $query = "SELECT * FROM `#__users` WHERE `id`=".$id ;
        $db->setQuery($query);
        return $rows = $db->loadObject();
}

public function usergrouplist(){
       $db =& JFactory::getDBO();
        $query = "SELECT `id`,`title` FROM #__usergroups" ;
        $db->setQuery($query);
        return $rows = $db->loadObjectList();
}

    public function attendanceReport($id){
        $data['task'] = 'getclassreport';
        $data['classId'] = $id;
        $bcvchelper_class = new bcvcHelper(); 
        $result = $bcvchelper_class->vlcr_get_curl_info($data);
        return $result; 
    }


   public function Getlistclass(){
        $db = JFactory::getDBO();
        $search    = JRequest::getVar('search');
        $data['limitstart'] = $this -> getState('limitstart');
        $data['limit'] = $this -> getState('limit');
        $data['search'] = $search;
        $data['task'] = 'listclass';
        $bcvchelper_class = new bcvcHelper(); 
        $result = $bcvchelper_class->vlcr_get_curl_info($data);
        return $result;
      
   }
   public function isteacher(){
        
        $db = JFactory::getDBO();
        $query = $db -> getQuery(true);
        $user = JFactory::getUser();
        $query -> select('is_teacher') -> from('#__virtualclassroom_teacher') -> where('user_id='.$user->id);

        $db -> setQuery($query);

        $db -> query();

        return $db -> loadResult();
        
    }
     public function isEnrolled($classid){
        
        $db = $this -> getDbo();
        $query = $db -> getQuery(true);
        $user = JFactory::getUser();
        $query -> select('count(*)') -> from('#__virtualclassroom_purchase') -> where('payer_id='.$user->id)-> where('class_id='.$classid);

        $db -> setQuery($query);

        $db -> query();

        return $db -> loadResult();
        
    }
 
}
