<?php
/**
 * @version     1.0.0
 * @package     com_virtualclassroom
 * @copyright   Copyright (C) 2014 BrainCert, Inc. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @website     https://www.braincert.com
 * @author      BrainCert
 */
 
defined('_JEXEC') or die;

jimport('joomla.application.component.modellist');

jimport('joomla.application.component.helper');
class virtualclassroomModelinvite_by_users extends JModelList {

   
    public function __construct($config = array()) {
        parent::__construct($config);
         
        $app =  JFactory::getApplication();
        $limit = $app -> getUserStateFromRequest('vc.list.limit', 'limit', $app -> getCfg('list_limit'), 'int');
        $limitstart = $app -> getUserStateFromRequest('vc' . '.limitstart', 'limitstart', 0, 'int');

        $this -> setState('limit', $limit);
        // Set the limit variable for query later on
        $this -> setState('limitstart', $limitstart);
    } 
    public function learnerPreview($id){
        $data['task'] = 'getclass';
        $data['class_id'] = $id;
        $bcvchelper_class = new bcvcHelper(); 
        $result = $bcvchelper_class->vlcr_get_curl_info($data);
        return $result;
    }
    public function userlist(){
        $db =& JFactory::getDBO();
        $query = "SELECT * FROM #__users" ;
        $db->setQuery($query);
        return $rows = $db->loadObjectList();
    }
    public function invite_by_email($data1){
        $db = JFactory::getDbo();
        if(empty($data1)){
         $data1=JRequest::get('post');
        }       
        
        $data['task'] = 'getclass';
        $data['class_id'] = $data1['id'];
        $classroom = virtualclassroomHelper::vlcr_get_curl_info($data);

        if($data1['subject'] == ''){ $data1['subject'] ='Live Class Invitation';}
         $subject =$data1['subject'];

        if($data1['email']){
         $data1['to'] = implode(',', $data1['email']);
        }
      
        $to = explode(',', $data1['to']);
        $class_id = $data1['id'];
        for($i=0;$i<count($to);$i++){      
            $receiver = trim($to[$i]);
            if( $receiver == '') continue;
            $uid = uniqid(md5(rand()), true);

            $query_string = "email=".$receiver."&token=".$uid;
            $encrypted_params = openssl_encrypt ($query_string, 'aes128', 'invite@123', false, 'invite@123');

            $shorturl = substr(uniqid(md5($receiver.$class_id, true)),-12);
            $rand_number=mt_rand(10000,99999);
            $query = $db->getQuery(true);
            $columns = array('shorturl', 'fullurl', 'rand_number');
            $values = array($db->quote($shorturl), $db->quote(addslashes($encrypted_params)),  $db->quote($rand_number));

            $query
            ->insert($db->quoteName('#__virtualclassroom_shorturl'))
            ->columns($db->quoteName($columns))
            ->values(implode(',', $values));
           
            // Set the query using our newly populated query object and execute it.
            $db->setQuery($query);
            $db->execute();
            $joinclassurl = JURI::root().'index.php?option=com_virtualclassroom&view=inviteclass&shurl='.$shorturl.'&cid='.$class_id;
           $current_user = JFactory::getUSER();


                        if($receiver){ 
                            $q1 = $db->getQuery(true);
                            $conditions = array(
                                $db->quoteName('class_id') . ' = '.$db->quote($class_id), 
                                $db->quoteName('email') . ' = ' . $db->quote($receiver)
                            );
                            $q1->delete($db->quoteName('#__virtualclassroom_shared_users'));
                            $q1->where($conditions);
                            $db->setQuery($q1);
                            $db->execute();
                        }

                       
                        $objdate = date('Y-m-d H:i:s');
                       
                        $q2 = $db->getQuery(true);
                        $columns = array('class_id','email', 'uid','date');
                        $values = array($class_id, $db->quote($receiver),  $db->quote($uid),  $db->quote($objdate));

                        $q2->insert($db->quoteName('#__virtualclassroom_shared_users'))
                        ->columns($db->quoteName($columns))
                        ->values(implode(',', $values));
                        $db->setQuery($q2);
                        $db->execute();

               ob_start();
             ?>
             <div>
                    <p>
                    <?php echo $current_user->username; ?> has invited you to join the Live Class at BrainCert.</p>
                    
                    <p>Class Name: <?php echo $classroom[0]['title'];?></p>
                    <p>Date/Time: <?php echo date('l F j, Y',strtotime($classroom[0]['date'])).' '. $classroom[0]['start_time'] .$classroom[0]['end_time'];?></p>
                     
                    <p>Time Zone: <?php echo $classroom[0]['timezone_label']; ?></p>
                    <p>Duration: <?php echo $classroom[0]['duration']/60; ?></p>

                    <p>Click on the link below to join the class:</p>
                    <p><a href="<?php echo $joinclassurl;?>"><?php echo $joinclassurl; ?></a></p>
                 
                   <p> Thank you.</p>
             </div>
             <?php
             $mail_body = ob_get_contents();
             ob_clean();
             echo  $mail_body;
             $jconfig = new JConfig();
             $from = $jconfig->mailfrom;
             $fromname = $jconfig->fromname;
             JFactory::getMailer()->sendMail($from, $fromname, $receiver, $subject, $mail_body, $mode=1);
        }
        return;
 
}
}
