<?php

/**
 * @version     1.0.0
 * @package     com_virtualclassroom
 * @copyright   Copyright (C) 2014 BrainCert, Inc. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @website 	https://www.braincert.com
 * @author      BrainCert
 */
 
defined('_JEXEC') or die;

jimport('joomla.application.component.modellist');

 
class virtualclassroomModellistclass extends JModelList {

    /**
     * Constructor.
     *
     * @param    array    An optional associative array of configuration settings.
     * @see        JController
     * @since    1.6
     */
    public function __construct($config = array()) {
        parent::__construct($config);
  		$app =  JFactory::getApplication();
	 	  $limit = 20;
	   	$limitstart = $app -> getUserStateFromRequest('vc' . '.limitstart', 'limitstart', 0, 'int');
		  $this -> setState('limit', $limit);
		  $this -> setState('limitstart', $limitstart);
    }
    function getplan(){
      $data['task'] = 'getplan';
      $result = virtualclassroomHelper::vlcr_get_curl_info($data);
      return $result;
    }
    public function learnerPreview($id){
        $data['task'] = 'getclass';
        $data['class_id'] = $id;
        $result = virtualclassroomHelper::vlcr_get_curl_info($data);
        return $result;
    }
    public function getrecorcount($class_id){
        $db = JFactory::getDBO();
        $search    = JRequest::getVar('search');
        $data['task'] = 'getclassrecording';
        $data['class_id'] = $class_id;
        $result = virtualclassroomHelper::vlcr_get_curl_info($data);
        return $result;
    }
    /**
     * Method to auto-populate the model state.
     *
     * Note. Calling getState in this method will result in recursion.
     *
     * @since	1.6
     */
    public function Getlistclass(){
     $db = JFactory::getDBO();
        $data['limitstart'] = $this -> getState('limitstart');
        $allowcalsslist = $this->getgroupclass();
        if(count($allowcalsslist) != 0 && !empty($allowcalsslist)){
                $data['limit'] = 0;
        }else{
           	$data['limit'] = $this -> getState('limit');
        }
        $data['published'] = "1";
        $data['task'] = 'listclass';
       
        $this->result = virtualclassroomHelper::vlcr_get_curl_info($data);
        return $this->result;
      
   }
   public function get_priceList($class_id){
      $data['class_id'] = $class_id;
      $data['task'] = 'listSchemes';
      $result = virtualclassroomHelper::vlcr_get_curl_info($data);
      return $result;
   }

   public function get_discountList($class_id){
      $data['class_id'] = $class_id;
      $data['task'] = 'listdiscount';
      $result = virtualclassroomHelper::vlcr_get_curl_info($data);
      return $result;
   }
    public function activeclass(){
      $app = JFactory::getApplication();
      $class_id = JRequest::getVar('id');
      $data['isCancel'] = 0;
      $data['class_id'] = $class_id;
      $data['task'] = 'cancelclass';
      $result = (object)virtualclassroomHelper::vlcr_get_curl_info($data);
      if($result->status=="ok"){
        $msg = "Class active successfully";
      }else{
        $msg = $result->error;
      }
      $url=JRoute::_("index.php?option=com_virtualclassroom&view=listclass");
      $app -> redirect($url,$msg);
    }
    public function cancelclass(){
      $app = JFactory::getApplication();
      $class_id = $_REQUEST['id'];
      $data['isCancel'] = $_REQUEST['isCancel'];
      $data['class_id'] = $class_id;
      $data['task'] = 'cancelclass';
      $result = (object)virtualclassroomHelper::vlcr_get_curl_info($data);
      if($result->status=="ok"){
        $msg = "Class cancel successfully";
      }else{
        $msg = $result->error;
      }
      $url=JRoute::_("index.php?option=com_virtualclassroom&view=listclass");
      $app -> redirect($url,$msg);
    }
    

   function class_checkout(){
      $key = JComponentHelper::getParams('com_virtualclassroom')->get('braincert_api_key');
      $base_url = JComponentHelper::getParams('com_virtualclassroom')->get('braincert_base_url');        
      $p_data = $_POST;

      $data['task'] = 'apiclasspayment';
      $data['apikey'] = $key;
      $data['class_id'] = $p_data['class_id'];
      $data['price_id'] = $p_data['price_id'];
      $data['cancelUrl'] = base64_encode($p_data['cancelUrl']);
      $data['returnUrl'] = base64_encode($p_data['returnUrl']);
      $data['card_holder_name'] = $p_data['card_holder_name'];
      $data['card_number'] = $p_data['card_number'];
      $data['card_cvc'] = $p_data['card_cvc'];
      $data['card_exp_month'] = $p_data['card_expiry_month'];
      $data['card_exp_year'] = $p_data['card_expiry_year'];
      $data['student_email'] = $p_data['student_email'];
      $data['coupon_code'] = $p_data['coupon_code'];
      $data_string = http_build_query($data);
      $ch = curl_init($base_url);
      curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");
      curl_setopt($ch, CURLOPT_POSTFIELDS, $data_string);
      curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
      curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false); 
      curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
      $result = curl_exec($ch);
      ob_clean();
      ob_start();
      echo $result;
      exit;
    }
    public function get_paymentInfo(){
      $data['task'] = 'getPaymentInfo';
      $result = virtualclassroomHelper::vlcr_get_curl_info($data);
      return $result;
   }
   function getPagination($total=0) {
	 
		 
			jimport('joomla.html.pagination');
			$this -> _pagination = new JPagination( $total, $this -> getState('limitstart'), $this -> getState('limit'));
 
	 

		return $this -> _pagination;
	}
    public function isEnrolled($classid){
        
        $db = $this -> getDbo();
        $query = $db -> getQuery(true);
        $user = JFactory::getUser();
        $query -> select('count(*)') -> from('#__virtualclassroom_purchase') -> where('payer_id='.$user->id)-> where('class_id='.$classid);

        $db -> setQuery($query);

        $db -> query();

        return $db -> loadResult();
        
    }
    public function setclasspayment(){
        $db = JFactory::getDBO();
        $user = JFactory::getUser();
        $data = $_REQUEST;
        $query = "INSERT INTO #__virtualclassroom_purchase (class_id,  mc_gross, payer_id,payment_mode,date_puchased) VALUES ('".$data['class_id']."','".$data['amount']."','".$user->id."','".$data['payment_mode']."',now())";

        $db -> setQuery($query);
        $db -> query();
        return $db->insertid();

    }
    public function isteacher(){
        
        $db = JFactory::getDBO();
        $query = $db -> getQuery(true);
        $user = JFactory::getUser();
        $query -> select('is_teacher') -> from('#__virtualclassroom_teacher') -> where('user_id='.$user->id);

        $db -> setQuery($query);

        $db -> query();

        return $db -> loadResult();
        
    }

        public function class_detail($id){

            $db = JFactory::getDBO();
            $data['task'] = 'getclass';
            $data['class_id'] = $id;
            $result = virtualclassroomHelper::vlcr_get_curl_info($data);
            return $result;
            
        }

     public function validatecoupon(){
            $db = JFactory::getDBO();
            $p_data = $_POST;
            $data['task'] = 'validatecoupon';
            $data['class_id'] = $p_data['class_id'];
            $data['coupon_code'] = $p_data['coupon_code'];
            $result = virtualclassroomHelper::vlcr_get_curl_info($data);
            echo $result;
            exit;
      }    
     public function getclasslaunch($class_id,$class_title,$instructor_id=NULL,$created_by=NULL){
        $db = JFactory::getDBO();
        $user = JFactory::getUser();
        $query="select * from #__virtualclassroom_teacher where user_id='".$user->id."' ";
        $db->setQuery($query);
        $teacher=$db->loadObject();

        $data['isTeacher'] = 0;
        if($instructor_id>0 && $instructor_id==$user->id){
          $data['isTeacher'] = 1;       
        }else if($created_by>0 && $created_by==$user->id){
          $data['isTeacher'] = 1;
        }else if($teacher->is_teacher == 1){
          $data['isTeacher'] = 1; 
        }

        $data['userId'] = $user->id;
        $data['userName'] = $user->name;
        $data['lessonName'] = $class_title;
        $data['courseName'] = $class_title;
        $data['task'] = 'getclasslaunch';
        $data['class_id'] = $class_id;
        
        $result = virtualclassroomHelper::vlcr_get_curl_info($data);
        return $result;
      
   }
      public function getgroupclass(){
        $db=JFactory::getDBO();
        $user = JFactory::getUser();
        $classlist_arr= array();
        foreach ($user->groups as $gid) {
            $q="SELECT `class_id` FROM `#__virtualclassroom_acl` WHERE `group_id`='".$gid."'";
            $db->setQuery($q);
            $class_list = $db->loadResult();

              if(!empty($class_list)){
                $classlist_arr[].=$class_list;
            }
        }
        $cidlist = implode(',', $classlist_arr);
        if($cidlist != ''){
          return $classlist_arr=explode(',', $cidlist);
        }else{
          return $classlist_arr='';
        }
   }
}
